# Chapter 10

Jump to navigation
Jump to search
[math]\displaystyle{
\begin{array}{|c|c|c|c|c|c|c|c||c|} length & 1 & 2 & 3 & 4 & 5 & 6 & 7 & 8\\
\hline
price&1&5&8&9&10&17&17&20\\
\end{array} }[/math]
[math]\displaystyle{ 6 + 2 * 0 - 4 }[/math]
[math]\displaystyle{ \sum_{i \in I} s_i = \sum_{i \notin I} s_i }[/math]
[math]\displaystyle{ [31, -41, 59, 26, -53, 58, 97, -93, -23, 84] }[/math]

## Contents

# Dynamic Programming

### Elementary Recurrences

- 10.1. Up to [math]\displaystyle{ k }[/math] steps in a single bound! A child is running up a staircase with [math]\displaystyle{ n }[/math] steps and can hop between 1 and [math]\displaystyle{ k }[/math] steps at a time. Design an algorithm to count how many possible ways the child can run up the stairs, as a function of [math]\displaystyle{ n }[/math] and [math]\displaystyle{ k }[/math]. What is the running time of your algorithm?

- 10.2. Imagine you are a professional thief who plans to rob houses along a street of [math]\displaystyle{ n }[/math] homes. You know the loot at house [math]\displaystyle{ i }[/math] is worth [math]\displaystyle{ m_i }[/math], for [math]\displaystyle{ 1 \le i \le n }[/math], but you cannot rob neighboring houses because their connected security systems will automatically contact the police if two adjacent houses are broken into. Give an efficient algorithm to determine the maximum amount of money you can steal without alerting the police.

- 10.3. Basketball games are a sequence of 2-point shots, 3-point shots, and 1-point free throws. Give an algorithm that computes how many possible mixes (1s,2s,3s) of scoring add up to a given [math]\displaystyle{ n }[/math]. For [math]\displaystyle{ n }[/math] = 5 there are four possible solutions: (5, 0, 0), (2, 0, 1), (1, 2, 0), and (0, 1, 1).

- 10.4. Basketball games are a sequence of 2-point shots, 3-point shots, and 1-point free throws. Give an algorithm that computes how many possible scoring sequences add up to a given [math]\displaystyle{ n }[/math]. For [math]\displaystyle{ n }[/math] = 5 there are thirteen possible sequences, including 1-2-1-1, 3-2, and 1-1-1-1-1.

- 10.5. Given an [math]\displaystyle{ s * t }[/math] grid filled with non-negative numbers, find a path from top left to bottom right that minimizes the sum of all numbers along its path. You can only move either down or right at any point in time.
- (a) Give a solution based on Dijkstra’s algorithm. What is its time complexity as a function of [math]\displaystyle{ s }[/math] and [math]\displaystyle{ t }[/math]?
- (b) Give a solution based on dynamic programming. What is its time complexity as a function of [math]\displaystyle{ s }[/math] and [math]\displaystyle{ t }[/math]?

### Edit Distance

- 10.6. Typists often make transposition errors exchanging neighboring characters, such as typing “setve” for “steve.” This requires two substitutions to fix under the conventional definition of edit distance.
- Incorporate a swap operation into our edit distance function, so that such neighboring transposition errors can be fixed at the cost of one operation.

- 10.7. Suppose you are given three strings of characters: [math]\displaystyle{ X }[/math], [math]\displaystyle{ Y }[/math], and [math]\displaystyle{ Z }[/math], where [math]\displaystyle{ |X| = n }[/math], [math]\displaystyle{ |Y| = m }[/math], and [math]\displaystyle{ |Z| = n + m }[/math]. [math]\displaystyle{ Z }[/math] is said to be a shuffle of [math]\displaystyle{ X }[/math] and [math]\displaystyle{ Y }[/math] iff [math]\displaystyle{ Z }[/math] can be formed by interleaving the characters from [math]\displaystyle{ X }[/math] and [math]\displaystyle{ Y }[/math] in a way that maintains the left-to-right ordering of the characters from each string.
- (a) Show that cchocohilaptes is a shuffle of chocolate and chips, but chocochilatspe is not.
- (b) Give an efficient dynamic programming algorithm that determines whether [math]\displaystyle{ Z }[/math] is a shuffle of [math]\displaystyle{ X }[/math] and [math]\displaystyle{ Y }[/math]. (Hint: the values of the dynamic programming matrix you construct should be Boolean, not numeric.)

- 10.8. The longest common substring (not subsequence) of two strings [math]\displaystyle{ X }[/math] and [math]\displaystyle{ Y }[/math] is the longest string that appears as a run of consecutive letters in both strings. For example, the longest common substring of photograph and tomography is ograph.
- (a) Let [math]\displaystyle{ n = |X| }[/math] and [math]\displaystyle{ m = |Y| }[/math]. Give a [math]\displaystyle{ \Theta (nm) }[/math] dynamic programming algorithm for longest common substring based on the longest common subsequence/edit distance algorithm.
- (b) Give a simpler [math]\displaystyle{ \Theta (nm) }[/math] algorithm that does not rely on dynamic programming.

- 10.9. The
*longest common subsequence (LCS)*of two sequences [math]\displaystyle{ T }[/math] and [math]\displaystyle{ P }[/math] is the longest sequence [math]\displaystyle{ L }[/math] such that [math]\displaystyle{ L }[/math] is a subsequence of both [math]\displaystyle{ T }[/math] and [math]\displaystyle{ P }[/math]. The*shortest common supersequence (SCS)*of [math]\displaystyle{ T }[/math] and [math]\displaystyle{ P }[/math] is the smallest sequence [math]\displaystyle{ L }[/math] such that both [math]\displaystyle{ T }[/math] and [math]\displaystyle{ P }[/math] are a subsequence of [math]\displaystyle{ L }[/math]. - (a) Give efficient algorithms to find the LCS and SCS of two given sequences.
- (b) Let [math]\displaystyle{ d(T, P) }[/math] be the minimum edit distance between [math]\displaystyle{ T }[/math] and [math]\displaystyle{ P }[/math] when no substitutions are allowed (i.e., the only changes are character insertion and deletion). Prove that [math]\displaystyle{ d(T, P) = |SCS(T, P)| - |LCS(T, P)| }[/math] where [math]\displaystyle{ |SCS(T, P)| (|LCS(T, P)|) }[/math] is the size of the shortest SCS (longest LCS) of [math]\displaystyle{ T }[/math] and [math]\displaystyle{ P }[/math].

- 10.10. Suppose you are given [math]\displaystyle{ n }[/math] poker chips stacked in two stacks, where the edges of all chips can be seen. Each chip is one of three colors. A turn consists of choosing a color and removing all chips of that color from the tops of the stacks. The goal is to minimize the number of turns until the chips are gone.
- For example, consider the stacks [math]\displaystyle{ (RRGG, GBBB) }[/math]. Playing red, green, and then blue suffices to clear the stacks in three moves. Give an [math]\displaystyle{ O(n^2) }[/math] dynamic programming algorithm to find the best strategy for a given pair of chip piles.

### Greedy Algorithms

- 10.11. Let [math]\displaystyle{ P_1, P_2, . . . , P_n }[/math] be [math]\displaystyle{ n }[/math] programs to be stored on a disk with capacity [math]\displaystyle{ D }[/math] megabytes. Program [math]\displaystyle{ P_i }[/math] requires [math]\displaystyle{ s_i }[/math] megabytes of storage. We cannot store them all because [math]\displaystyle{ D \lt \sum_{i=1}^n s_i }[/math]
- (a) Does a greedy algorithm that selects programs in order of non-decreasing [math]\displaystyle{ s_i }[/math] maximize the number of programs held on the disk? Prove or give a counter-example.
- (b) Does a greedy algorithm that selects programs in order of non-increasing [math]\displaystyle{ s_i }[/math] use as much of the capacity of the disk as possible? Prove or give a counter-example.

- 10.12. Coins in the United States are minted with denominations of 1, 5, 10, 25, and 50 cents. Now consider a country whose coins are minted with denominations of [math]\displaystyle{ {d_1, . . . , d_k} }[/math] units. We seek an algorithm to make change of [math]\displaystyle{ n }[/math] units using the minimum number of this country’s coins.
- (a) The greedy algorithm repeatedly selects the biggest coin no bigger than the amount to be changed and repeats until it is zero. Show that the greedy algorithm does not always use the minimum number of coins in a country whose denominations are {1, 6, 10}.
- (b) Give an efficient algorithm that correctly determines the minimum number of coins needed to make change of [math]\displaystyle{ n }[/math] units using denominations [math]\displaystyle{ {d_1, . . . , d_k} }[/math]. Analyze its running time.

- 10.13. Coins in the United States are minted with denominations of 1, 5, 10, 25, and 50 cents. Now consider a country whose coins are minted with denominations of [math]\displaystyle{ {d_1, . . . , d_k} }[/math] units. We want to count how many distinct ways [math]\displaystyle{ C(n) }[/math] there are to make change of [math]\displaystyle{ n }[/math] units. For example, in a country whose denominations are {1, 6, 10}, [math]\displaystyle{ C(5) = 1 }[/math], [math]\displaystyle{ C(6) }[/math] to [math]\displaystyle{ C(9) = 2 }[/math], [math]\displaystyle{ C(10) = 3 }[/math], and [math]\displaystyle{ C(12) = 4 }[/math].
- (a) How many ways are there to make change of 20 units from {1, 6, 10}?
- (b) Give an efficient algorithm to compute [math]\displaystyle{ C(n) }[/math], and analyze its complexity. (Hint: think in terms of computing [math]\displaystyle{ C(n, d) }[/math], the number of ways to make change of [math]\displaystyle{ n }[/math] units with highest denomination [math]\displaystyle{ d }[/math]. Be careful to avoid overcounting.)

- 10.14. In the single-processor scheduling problem, we are given a set of [math]\displaystyle{ n }[/math] jobs [math]\displaystyle{ J }[/math]. Each job [math]\displaystyle{ i }[/math] has a processing time [math]\displaystyle{ t_i }[/math], and a deadline [math]\displaystyle{ d_i }[/math]. A feasible schedule is a permutation of the jobs such that when the jobs are performed in that order, every job is finished before its deadline. The greedy algorithm for single-processor scheduling selects the job with the earliest deadline first.
- Show that if a feasible schedule exists, then the schedule produced by this greedy algorithm is feasible.

### Number Problems

- 10.15. You are given a rod of length [math]\displaystyle{ n }[/math] inches and a table of prices obtainable for rod-pieces of size [math]\displaystyle{ n }[/math] or smaller. Give an efficient algorithm to find the maximum value obtainable by cutting up the rod and selling the pieces. For example, if [math]\displaystyle{ n=8 }[/math] and the values of different pieces are:

- then the maximum obtainable value is 22, by cutting into pieces of lengths 2 and 6.

- 10.16. Your boss has written an arithmetic expression of n terms to compute your annual bonus, but permits you to parenthesize it however you wish. Give an efficient algorithm to design the parenthesization to maximize the value. For the expression:

- there exist parenthesizations with values ranging from −32 to 2.

- 10.17. Given a positive integer [math]\displaystyle{ n }[/math], find an efficient algorithm to compute the smallest number of perfect squares (e.g. 1, 4, 9, 16, . . .) that sum to [math]\displaystyle{ n }[/math]. What is the running time of your algorithm?

- 10.18. Given an array [math]\displaystyle{ A }[/math] of [math]\displaystyle{ n }[/math] integers, find an efficient algorithm to compute the largest sum of a continuous run. For [math]\displaystyle{ A = [-3, 2, 7, -3, 4, -2, 0, 1] }[/math], the largest such sum is 10, from the second through fifth positions.

- 10.19. Two drivers have to divide up [math]\displaystyle{ m }[/math] suitcases between them, where the weight of the [math]\displaystyle{ ith }[/math] suitcase is [math]\displaystyle{ w_i }[/math]. Give an efficient algorithm to divide up the loads so the two drivers carry equal weight, if possible.

- 10.20. The
*knapsack problem*is as follows: given a set of integers [math]\displaystyle{ S = {s_1, s_2, . . . , s_n} }[/math], and a given target number [math]\displaystyle{ T }[/math], find a subset of [math]\displaystyle{ S }[/math] that adds up exactly to [math]\displaystyle{ T }[/math]. For example, within [math]\displaystyle{ S = {1, 2, 5, 9, 10} }[/math] there is a subset that adds up to [math]\displaystyle{ T = 22 }[/math] but not [math]\displaystyle{ T = 23 }[/math]. - Give a dynamic programming algorithm for knapsack that runs in [math]\displaystyle{ O(nT) }[/math] time.

- 10.21. The integer partition takes a set of positive integers [math]\displaystyle{ S = {s_1, . . . , s_n} }[/math] and seeks a subset [math]\displaystyle{ I \subset S }[/math] such that

- Let [math]\displaystyle{ \sum_{i \in S} s_i = M }[/math]. Give an [math]\displaystyle{ O(nM) }[/math] dynamic programming algorithm to solve the integer partition problem.

- 10.22. Assume that there are n numbers (some possibly negative) on a circle, and we wish to find the maximum contiguous sum along an arc of the circle. Give an efficient algorithm for solving this problem.

- 10.23. A certain string processing language allows the programmer to break a string into two pieces. It costs [math]\displaystyle{ n }[/math] units of time to break a string of [math]\displaystyle{ n }[/math] characters into two pieces, since this involves copying the old string. A programmer wants to break a string into many pieces, and the order in which the breaks are made can affect the total amount of time used. For example, suppose we wish to break a 20-character string after characters 3, 8, and 10. If the breaks are made in left-to-right order, then the first break costs 20 units of time, the second break costs 17 units of time, and the third break costs 12 units of time, for a total of 49 units. If the breaks are made in right-to-left order, the first break costs 20 units of time, the second break costs 10 units of time, and the third break costs 8 units of time, for a total of only 38 units.
- Give a dynamic programming algorithm that takes a list of character positions after which to break and determines the cheapest break cost in [math]\displaystyle{ O(n^3) }[/math] time.

- 10.24. Consider the following data compression technique. We have a table of [math]\displaystyle{ m }[/math] text strings, each at most [math]\displaystyle{ k }[/math] in length. We want to encode a data string [math]\displaystyle{ D }[/math] of length [math]\displaystyle{ n }[/math] using as few text strings as possible. For example, if our table contains [math]\displaystyle{ (a,ba,abab,b) }[/math] and the data string is [math]\displaystyle{ bababbaababa }[/math], the best way to encode it is [math]\displaystyle{ (b,abab,ba,abab,a)-a }[/math] total of five code words. Give an [math]\displaystyle{ O(nmk) }[/math] algorithm to find the length of the best encoding. You may assume that every string has at least one encoding in terms of the table.

- 10.25. The traditional world chess championship is a match of 24 games. The current champion retains the title in case the match is a tie. Each game ends in a win, loss, or draw (tie) where wins count as 1, losses as 0, and draws as [math]\displaystyle{ 1/2 }[/math]. The players take turns playing white and black. White plays first and so has an advantage. The champion plays white in the first game. The champ has probabilities [math]\displaystyle{ w_w }[/math], [math]\displaystyle{ w_d }[/math], and [math]\displaystyle{ w_l }[/math] of winning, drawing, and losing playing white, and has probabilities [math]\displaystyle{ b_w }[/math], [math]\displaystyle{ b_d }[/math], and [math]\displaystyle{ b_l }[/math] of winning, drawing, and losing playing black.
- (a) Write a recurrence for the probability that the champion retains the title. Assume that there are [math]\displaystyle{ g }[/math] games left to play in the match and that the champion needs to get [math]\displaystyle{ i }[/math] points (which may be a multiple of [math]\displaystyle{ 1/2 }[/math]).
- (b) Based on your recurrence, give a dynamic programming algorithm to calculate the champion’s probability of retaining the title.
- (c) Analyze its running time for an [math]\displaystyle{ n }[/math] game match.

- 10.26. Eggs break when dropped from great enough height. Specifically, there must be a floor [math]\displaystyle{ f }[/math] in any sufficiently tall building such that an egg dropped from the [math]\displaystyle{ f }[/math]th floor breaks, but one dropped from the [math]\displaystyle{ (f - 1) }[/math]st floor will not. If the egg always breaks, then [math]\displaystyle{ f = 1 }[/math]. If the egg never breaks, then [math]\displaystyle{ f = n + 1 }[/math].
- You seek to find the critical floor [math]\displaystyle{ f }[/math] using an [math]\displaystyle{ n-floor }[/math] building. The only operation you can perform is to drop an egg off some floor and see what happens. You start out with [math]\displaystyle{ k }[/math] eggs, and seek to make as few drops as possible. Broken eggs cannot be reused. Let [math]\displaystyle{ E(k, n) }[/math] be the minimum number of egg drops that will always suffice.
- (a) Show that [math]\displaystyle{ E(1, n) = n }[/math].
- (b) Show that [math]\displaystyle{ E(k, n) = \Theta (n^{1/k}) }[/math].
- (c) Find a recurrence for [math]\displaystyle{ E(k, n) }[/math]. What is the running time of the dynamic program to find [math]\displaystyle{ E(k, n) }[/math]?

### Graphing Problem

- 10.27. Consider a city whose streets are defined by an [math]\displaystyle{ X * Y }[/math] grid. We are interested in walking from the upper left-hand corner of the grid to the lower right-hand corner.
- Unfortunately, the city has bad neighborhoods, whose intersections we do not want to walk in. We are given an [math]\displaystyle{ X * Y }[/math] matrix bad, where [math]\displaystyle{ bad[i,j] = }[/math] “yes” iff the intersection between streets [math]\displaystyle{ i }[/math] and [math]\displaystyle{ j }[/math] is in a neighborhood to avoid.
- (a) Give an example of the contents of bad such that there is no path across the grid avoiding bad neighborhoods.
- (b) Give an [math]\displaystyle{ O(XY) }[/math] algorithm to find a path across the grid that avoids bad neighborhoods.
- (c) Give an [math]\displaystyle{ O(XY) }[/math] algorithm to find the shortest path across the grid that avoids bad neighborhoods. You may assume that all blocks are of equal length. For partial credit, give an [math]\displaystyle{ O(X^2Y^2) }[/math] algorithm.

- 10.28. Consider the same situation as the previous problem. We have a city whose streets are defined by an [math]\displaystyle{ X * Y }[/math] grid. We are interested in walking from the upper left-hand corner of the grid to the lower right-hand corner. We are given an [math]\displaystyle{ X * Y }[/math] matrix bad, where [math]\displaystyle{ bad[i,j] = }[/math] “yes” iff the intersection between streets [math]\displaystyle{ i }[/math] and [math]\displaystyle{ j }[/math] is somewhere we want to avoid.
- If there were no bad neighborhoods to contend with, the shortest path across the grid would have length [math]\displaystyle{ (X - 1) + (Y - 1) }[/math] blocks, and indeed there would be many such paths across the grid. Each path would consist of only rightward and downward moves.
- Give an algorithm that takes the array bad and returns the number of safe paths of length [math]\displaystyle{ X + Y - 2 }[/math]. For full credit, your algorithm must run in [math]\displaystyle{ O(XY) }[/math].

- 10.29. You seek to create a stack out of [math]\displaystyle{ n }[/math] boxes, where box [math]\displaystyle{ i }[/math] has width [math]\displaystyle{ w_i }[/math], height [math]\displaystyle{ h_i }[/math], and depth [math]\displaystyle{ d_i }[/math]. The boxes cannot be rotated, and can only be stacked on top of one another when each box in the stack is strictly larger than the box above it in width, height, and depth. Give an efficient algorithm to construct the tallest possible stack, where the height is the sum of the heights of each box in the stack.

### Design Problems

- 10.30. Consider the problem of storing [math]\displaystyle{ n }[/math] books on shelves in a library. The order of the books is fixed by the cataloging system and so cannot be rearranged. Therefore, we can speak of a book [math]\displaystyle{ b_i }[/math], where [math]\displaystyle{ 1 \leq i \leq n }[/math], that has a thickness [math]\displaystyle{ t_i }[/math] and height [math]\displaystyle{ h_i }[/math]. The length of each bookshelf at this library is [math]\displaystyle{ L }[/math].
- Suppose all the books have the same height [math]\displaystyle{ h }[/math] (i.e., [math]\displaystyle{ h = h_i }[/math] for all [math]\displaystyle{ i }[/math]) and the shelves are all separated by a distance greater than [math]\displaystyle{ h }[/math], so any book fits on any shelf. The greedy algorithm would fill the first shelf with as many books as we can until we get the smallest [math]\displaystyle{ i }[/math] such that [math]\displaystyle{ b_i }[/math] does not fit, and then repeat with subsequent shelves. Show that the greedy algorithm always finds the book placement that uses the minimum number of shelves, and analyze its time complexity.

- 10.31. This is a generalization of the previous problem. Now consider the case where the height of the books is not constant, but we have the freedom to adjust the height of each shelf to that of the tallest book on the shelf. Here the cost of a particular layout is the sum of the heights of the largest book on each shelf.
- Give an example to show that the greedy algorithm of stuffing each shelf as full as possible does not always give the minimum overall height.
- Give an algorithm for this problem, and analyze its time complexity. (Hint: use dynamic programming.)

- 10.32. Consider a linear keyboard of lowercase letters and numbers, where the left-most 26 keys are the letters A–Z in order, followed by the digits 0–9 in order, followed by the 30 punctuation characters in a prescribed order, and ended on a blank. Assume you start with your left index finger on the “A” and your right index finger on the blank.
- Give a dynamic programming algorithm that finds the most efficient way to type a given text of length [math]\displaystyle{ n }[/math], in terms of minimizing total movement of the fingers involved. For the text [math]\displaystyle{ ABABABAB . . . ABAB }[/math], this would involve shifting both fingers all the way to the left side of the keyboard. Analyze the complexity of your algorithm as a function of [math]\displaystyle{ n }[/math] and [math]\displaystyle{ k }[/math], the number of keys on the keyboard.

- 10.33. You have come back from the future with an array [math]\displaystyle{ G }[/math], where [math]\displaystyle{ G[i] }[/math] tells you the price of Google stock [math]\displaystyle{ i }[/math] days from now, for [math]\displaystyle{ 1 \leq i \leq n }[/math]. You seek to use this information to maximize your profit, but are only permitted to complete at most one transaction (i.e. either buy one or sell one share of the stock) per day. Design an efficient algorithm to construct the buy–sell sequence to maximize your profit. Note that you cannot sell a share unless you currently own one.

- 10.34. You are given a string of [math]\displaystyle{ n }[/math] characters [math]\displaystyle{ S = s_1 . . . s_n }[/math], which you believe to be a compressed text document in which all spaces have been removed, like
**itwasthebestoftimes**. - (a) You seek to reconstruct the document using a dictionary, which is available in the form of a Boolean function [math]\displaystyle{ dict(w) }[/math], where [math]\displaystyle{ dict(w) }[/math] is true iff string [math]\displaystyle{ w }[/math] is a valid word in the language. Give an [math]\displaystyle{ O(n^2) }[/math] algorithm to determine whether string [math]\displaystyle{ S }[/math] can be reconstituted as a sequence of valid words, assuming calls to [math]\displaystyle{ dict(w }[/math] take unit time.
- (b) Now assume you are given the dictionary as a set of [math]\displaystyle{ m }[/math] words each of length at most l. Give an efficient algorithm to determine whether string [math]\displaystyle{ S }[/math] can be reconstituted as a sequence of valid words, and its running time.

- 10.35. Consider the following two-player game, where you seek to get the biggest score. You start with an n-digit integer [math]\displaystyle{ N }[/math]. With each move, you get to take either the first digit or the last digit from what is left of [math]\displaystyle{ N }[/math], and add that to your score, with your opponent then doing the same thing to the now smaller number. You continue taking turns removing digits until none are left. Give an efficient algorithm that finds the best possible score that the first player can get for a given digit string [math]\displaystyle{ N }[/math], assuming the second player is as smart as can be.

- 10.36. Given an array of [math]\displaystyle{ n }[/math] real numbers, consider the problem of finding the maximum sum in any contiguous subarray of the input. For example, in the array

- the maximum is achieved by summing the third through seventh elements, where 59 + 26 + (−53) + 58 + 97 = 187. When all numbers are positive, the entire array is the answer, while when all numbers are negative, the empty array maximizes the total at 0.

- Give a simple and clear [math]\displaystyle{ \Theta (n^2) }[/math]-time algorithm to find the maximum contiguous subarray.
- Now give a [math]\displaystyle{ \Theta (n) }[/math]-time dynamic programming algorithm for this problem. To get partial credit, you may instead give a correct [math]\displaystyle{ O(n log n) }[/math] divide-and-conquer algorithm.

- 10.37. Consider the problem of examining a string [math]\displaystyle{ x = x_1 x_2 \ldots x_n }[/math] from an alphabet of [math]\displaystyle{ k }[/math] symbols, and a multiplication table over this alphabet. Decide whether or not it is possible to parenthesize [math]\displaystyle{ x }[/math] in such a way that the value of the resulting expression is [math]\displaystyle{ a }[/math], where [math]\displaystyle{ a }[/math] belongs to the alphabet. The multiplication table is neither commutative or associative, so the order of multiplication matters.

[math]\displaystyle{ \begin{array}{c|ccc} & a & b & c \\ \hline a & a & c & c \\ b & a & a & b \\ c & c & c & c \\ \end{array} }[/math]

- For example, consider the above multiplication table and the string [math]\displaystyle{ bbbba }[/math]. Parenthesizing it [math]\displaystyle{ (b(bb))(ba) }[/math] gives [math]\displaystyle{ a }[/math], but [math]\displaystyle{ ((((bb)b)b)a) }[/math] gives [math]\displaystyle{ c }[/math].
- Give an algorithm, with time polynomial in [math]\displaystyle{ n }[/math] and [math]\displaystyle{ k }[/math], to decide whether such a parenthesization exists for a given string, multiplication table, and goal element.

- 10.38. Let α and β be constants. Assume that it costs α to go left in a binary search tree, and β to go right. Devise an algorithm that builds a tree with optimal expected query cost, given keys [math]\displaystyle{ k_1, . . . , k_n }[/math] and the probabilities that each will be searched [math]\displaystyle{ p_1, . . . , p_n }[/math].

### Interview Problems

- 10.39. Given a set of coin denominations, find the minimum number of coins to make a certain amount of change.

- 10.40. You are given an array of n numbers, each of which may be positive, negative, or zero. Give an efficient algorithm to identify the index positions [math]\displaystyle{ i }[/math] and [math]\displaystyle{ j }[/math] to obtain the maximum sum of the [math]\displaystyle{ i }[/math]th through [math]\displaystyle{ j }[/math]th numbers.

- 10.41. Observe that when you cut a character out of a magazine, the character on the reverse side of the page is also removed. Give an algorithm to determine whether you can generate a given string by pasting cutouts from a given magazine. Assume that you are given a function that will identify the character and its position on the reverse side of the page for any given character position.

Back to Chapter List